puts "Info:(TE) This block design file has been exported with Reference-Design Scripts from Trenz Electronic GmbH for Board Part:trenz.biz:te0714_35_2i:part0:1.0 with FPGA xc7a35tcsg325-2 at 2016-09-05T10:28:55."

################################################################
# This is a generated script based on design: fsys
#
# Though there are limitations about the generated script,
# the main purpose of this utility is to make learning
# IP Integrator Tcl commands easier.
################################################################

namespace eval _tcl {
proc get_script_folder {} {
   set script_path [file normalize [info script]]
   set script_folder [file dirname $script_path]
   return $script_folder
}
}
variable script_folder
set script_folder [_tcl::get_script_folder]

################################################################
# Check if script is running in correct Vivado version.
################################################################
set scripts_vivado_version 2016.2
set current_vivado_version [version -short]

if { [string first $scripts_vivado_version $current_vivado_version] == -1 } {
   puts ""
   catch {common::send_msg_id "BD_TCL-109" "ERROR" "This script was generated using Vivado <$scripts_vivado_version> and is being run in <$current_vivado_version> of Vivado. Please run the script in Vivado <$scripts_vivado_version> then open the design in Vivado <$current_vivado_version>. Upgrade the design by running \"Tools => Report => Report IP Status...\", then run write_bd_tcl to create an updated script."}

   return 1
}

################################################################
# START
################################################################

# To test this script, run the following commands from Vivado Tcl console:
# source fsys_script.tcl

# If there is no project opened, this script will create a
# project, but make sure you do not have an existing project
# <./myproj/project_1.xpr> in the current working folder.

set list_projs [get_projects -quiet]
if { $list_projs eq "" } {
   create_project project_1 myproj -part xc7a35tcsg325-2
   set_property BOARD_PART trenz.biz:te0714_35_2i:part0:1.0 [current_project]
}


# CHANGE DESIGN NAME HERE
set design_name fsys

# If you do not already have an existing IP Integrator design open,
# you can create a design using the following command:
#    create_bd_design $design_name

# Creating design if needed
set errMsg ""
set nRet 0

set cur_design [current_bd_design -quiet]
set list_cells [get_bd_cells -quiet]

if { ${design_name} eq "" } {
   # USE CASES:
   #    1) Design_name not set

   set errMsg "Please set the variable <design_name> to a non-empty value."
   set nRet 1

} elseif { ${cur_design} ne "" && ${list_cells} eq "" } {
   # USE CASES:
   #    2): Current design opened AND is empty AND names same.
   #    3): Current design opened AND is empty AND names diff; design_name NOT in project.
   #    4): Current design opened AND is empty AND names diff; design_name exists in project.

   if { $cur_design ne $design_name } {
      common::send_msg_id "BD_TCL-001" "INFO" "Changing value of <design_name> from <$design_name> to <$cur_design> since current design is empty."
      set design_name [get_property NAME $cur_design]
   }
   common::send_msg_id "BD_TCL-002" "INFO" "Constructing design in IPI design <$cur_design>..."

} elseif { ${cur_design} ne "" && $list_cells ne "" && $cur_design eq $design_name } {
   # USE CASES:
   #    5) Current design opened AND has components AND same names.

   set errMsg "Design <$design_name> already exists in your project, please set the variable <design_name> to another value."
   set nRet 1
} elseif { [get_files -quiet ${design_name}.bd] ne "" } {
   # USE CASES: 
   #    6) Current opened design, has components, but diff names, design_name exists in project.
   #    7) No opened design, design_name exists in project.

   set errMsg "Design <$design_name> already exists in your project, please set the variable <design_name> to another value."
   set nRet 2

} else {
   # USE CASES:
   #    8) No opened design, design_name not in project.
   #    9) Current opened design, has components, but diff names, design_name not in project.

   common::send_msg_id "BD_TCL-003" "INFO" "Currently there is no design <$design_name> in project, so creating one..."

   create_bd_design $design_name

   common::send_msg_id "BD_TCL-004" "INFO" "Making design <$design_name> as current_bd_design."
   current_bd_design $design_name

}

common::send_msg_id "BD_TCL-005" "INFO" "Currently the variable <design_name> is equal to \"$design_name\"."

if { $nRet != 0 } {
   catch {common::send_msg_id "BD_TCL-114" "ERROR" $errMsg}
   return $nRet
}

##################################################################
# DESIGN PROCs
##################################################################


# Hierarchical cell: mux_2to1_3
proc create_hier_cell_mux_2to1_3 { parentCell nameHier } {

  variable script_folder

  if { $parentCell eq "" || $nameHier eq "" } {
     catch {common::send_msg_id "BD_TCL-102" "ERROR" create_hier_cell_mux_2to1_3() - Empty argument(s)!"}
     return
  }

  # Get object for parentCell
  set parentObj [get_bd_cells $parentCell]
  if { $parentObj == "" } {
     catch {common::send_msg_id "BD_TCL-100" "ERROR" "Unable to find parent cell <$parentCell>!"}
     return
  }

  # Make sure parentObj is hier blk
  set parentType [get_property TYPE $parentObj]
  if { $parentType ne "hier" } {
     catch {common::send_msg_id "BD_TCL-101" "ERROR" "Parent <$parentObj> has TYPE = <$parentType>. Expected to be <hier>."}
     return
  }

  # Save current instance; Restore later
  set oldCurInst [current_bd_instance .]

  # Set parent object as current
  current_bd_instance $parentObj

  # Create cell and set as current instance
  set hier_obj [create_bd_cell -type hier $nameHier]
  current_bd_instance $hier_obj

  # Create interface pins

  # Create pins
  create_bd_pin -dir I -from 0 -to 0 A
  create_bd_pin -dir I -from 0 -to 0 B
  create_bd_pin -dir O -from 0 -to 0 C
  create_bd_pin -dir I -from 0 -to 0 SEL

  # Create instance: util_vector_logic_0, and set properties
  set util_vector_logic_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:util_vector_logic:2.0 util_vector_logic_0 ]
  set_property -dict [ list \
CONFIG.C_SIZE {1} \
 ] $util_vector_logic_0

  # Create instance: util_vector_logic_1, and set properties
  set util_vector_logic_1 [ create_bd_cell -type ip -vlnv xilinx.com:ip:util_vector_logic:2.0 util_vector_logic_1 ]
  set_property -dict [ list \
CONFIG.C_OPERATION {not} \
CONFIG.C_SIZE {1} \
CONFIG.LOGO_FILE {data/sym_notgate.png} \
 ] $util_vector_logic_1

  # Create instance: util_vector_logic_2, and set properties
  set util_vector_logic_2 [ create_bd_cell -type ip -vlnv xilinx.com:ip:util_vector_logic:2.0 util_vector_logic_2 ]
  set_property -dict [ list \
CONFIG.C_OPERATION {or} \
CONFIG.C_SIZE {1} \
CONFIG.LOGO_FILE {data/sym_orgate.png} \
 ] $util_vector_logic_2

  # Create instance: util_vector_logic_3, and set properties
  set util_vector_logic_3 [ create_bd_cell -type ip -vlnv xilinx.com:ip:util_vector_logic:2.0 util_vector_logic_3 ]
  set_property -dict [ list \
CONFIG.C_SIZE {1} \
 ] $util_vector_logic_3

  # Create port connections
  connect_bd_net -net STARTUP_0_user_clk [get_bd_pins A] [get_bd_pins util_vector_logic_0/Op1]
  connect_bd_net -net util_ds_buf_0_BUFG_O [get_bd_pins B] [get_bd_pins util_vector_logic_3/Op1]
  connect_bd_net -net util_vector_logic_0_Res [get_bd_pins util_vector_logic_0/Res] [get_bd_pins util_vector_logic_2/Op1]
  connect_bd_net -net util_vector_logic_1_Res [get_bd_pins util_vector_logic_0/Op2] [get_bd_pins util_vector_logic_1/Res]
  connect_bd_net -net util_vector_logic_2_Res [get_bd_pins C] [get_bd_pins util_vector_logic_2/Res]
  connect_bd_net -net util_vector_logic_3_Res [get_bd_pins util_vector_logic_2/Op2] [get_bd_pins util_vector_logic_3/Res]
  connect_bd_net -net vio_0_probe_out0 [get_bd_pins SEL] [get_bd_pins util_vector_logic_1/Op1] [get_bd_pins util_vector_logic_3/Op2]

  # Restore current instance
  current_bd_instance $oldCurInst
}

# Hierarchical cell: mux_2to1_2
proc create_hier_cell_mux_2to1_2 { parentCell nameHier } {

  variable script_folder

  if { $parentCell eq "" || $nameHier eq "" } {
     catch {common::send_msg_id "BD_TCL-102" "ERROR" create_hier_cell_mux_2to1_2() - Empty argument(s)!"}
     return
  }

  # Get object for parentCell
  set parentObj [get_bd_cells $parentCell]
  if { $parentObj == "" } {
     catch {common::send_msg_id "BD_TCL-100" "ERROR" "Unable to find parent cell <$parentCell>!"}
     return
  }

  # Make sure parentObj is hier blk
  set parentType [get_property TYPE $parentObj]
  if { $parentType ne "hier" } {
     catch {common::send_msg_id "BD_TCL-101" "ERROR" "Parent <$parentObj> has TYPE = <$parentType>. Expected to be <hier>."}
     return
  }

  # Save current instance; Restore later
  set oldCurInst [current_bd_instance .]

  # Set parent object as current
  current_bd_instance $parentObj

  # Create cell and set as current instance
  set hier_obj [create_bd_cell -type hier $nameHier]
  current_bd_instance $hier_obj

  # Create interface pins

  # Create pins
  create_bd_pin -dir I -from 0 -to 0 A
  create_bd_pin -dir I -from 0 -to 0 B
  create_bd_pin -dir O -from 0 -to 0 C
  create_bd_pin -dir I -from 0 -to 0 SEL

  # Create instance: util_vector_logic_0, and set properties
  set util_vector_logic_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:util_vector_logic:2.0 util_vector_logic_0 ]
  set_property -dict [ list \
CONFIG.C_SIZE {1} \
 ] $util_vector_logic_0

  # Create instance: util_vector_logic_1, and set properties
  set util_vector_logic_1 [ create_bd_cell -type ip -vlnv xilinx.com:ip:util_vector_logic:2.0 util_vector_logic_1 ]
  set_property -dict [ list \
CONFIG.C_OPERATION {not} \
CONFIG.C_SIZE {1} \
CONFIG.LOGO_FILE {data/sym_notgate.png} \
 ] $util_vector_logic_1

  # Create instance: util_vector_logic_2, and set properties
  set util_vector_logic_2 [ create_bd_cell -type ip -vlnv xilinx.com:ip:util_vector_logic:2.0 util_vector_logic_2 ]
  set_property -dict [ list \
CONFIG.C_OPERATION {or} \
CONFIG.C_SIZE {1} \
CONFIG.LOGO_FILE {data/sym_orgate.png} \
 ] $util_vector_logic_2

  # Create instance: util_vector_logic_3, and set properties
  set util_vector_logic_3 [ create_bd_cell -type ip -vlnv xilinx.com:ip:util_vector_logic:2.0 util_vector_logic_3 ]
  set_property -dict [ list \
CONFIG.C_SIZE {1} \
 ] $util_vector_logic_3

  # Create port connections
  connect_bd_net -net STARTUP_0_user_clk [get_bd_pins A] [get_bd_pins util_vector_logic_0/Op1]
  connect_bd_net -net util_ds_buf_0_BUFG_O [get_bd_pins B] [get_bd_pins util_vector_logic_3/Op1]
  connect_bd_net -net util_vector_logic_0_Res [get_bd_pins util_vector_logic_0/Res] [get_bd_pins util_vector_logic_2/Op1]
  connect_bd_net -net util_vector_logic_1_Res [get_bd_pins util_vector_logic_0/Op2] [get_bd_pins util_vector_logic_1/Res]
  connect_bd_net -net util_vector_logic_2_Res [get_bd_pins C] [get_bd_pins util_vector_logic_2/Res]
  connect_bd_net -net util_vector_logic_3_Res [get_bd_pins util_vector_logic_2/Op2] [get_bd_pins util_vector_logic_3/Res]
  connect_bd_net -net vio_0_probe_out0 [get_bd_pins SEL] [get_bd_pins util_vector_logic_1/Op1] [get_bd_pins util_vector_logic_3/Op2]

  # Restore current instance
  current_bd_instance $oldCurInst
}

# Hierarchical cell: mux_2to1_1
proc create_hier_cell_mux_2to1_1 { parentCell nameHier } {

  variable script_folder

  if { $parentCell eq "" || $nameHier eq "" } {
     catch {common::send_msg_id "BD_TCL-102" "ERROR" create_hier_cell_mux_2to1_1() - Empty argument(s)!"}
     return
  }

  # Get object for parentCell
  set parentObj [get_bd_cells $parentCell]
  if { $parentObj == "" } {
     catch {common::send_msg_id "BD_TCL-100" "ERROR" "Unable to find parent cell <$parentCell>!"}
     return
  }

  # Make sure parentObj is hier blk
  set parentType [get_property TYPE $parentObj]
  if { $parentType ne "hier" } {
     catch {common::send_msg_id "BD_TCL-101" "ERROR" "Parent <$parentObj> has TYPE = <$parentType>. Expected to be <hier>."}
     return
  }

  # Save current instance; Restore later
  set oldCurInst [current_bd_instance .]

  # Set parent object as current
  current_bd_instance $parentObj

  # Create cell and set as current instance
  set hier_obj [create_bd_cell -type hier $nameHier]
  current_bd_instance $hier_obj

  # Create interface pins

  # Create pins
  create_bd_pin -dir I -from 0 -to 0 A
  create_bd_pin -dir I -from 0 -to 0 B
  create_bd_pin -dir O -from 0 -to 0 C
  create_bd_pin -dir I -from 0 -to 0 SEL

  # Create instance: util_vector_logic_0, and set properties
  set util_vector_logic_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:util_vector_logic:2.0 util_vector_logic_0 ]
  set_property -dict [ list \
CONFIG.C_SIZE {1} \
 ] $util_vector_logic_0

  # Create instance: util_vector_logic_1, and set properties
  set util_vector_logic_1 [ create_bd_cell -type ip -vlnv xilinx.com:ip:util_vector_logic:2.0 util_vector_logic_1 ]
  set_property -dict [ list \
CONFIG.C_OPERATION {not} \
CONFIG.C_SIZE {1} \
CONFIG.LOGO_FILE {data/sym_notgate.png} \
 ] $util_vector_logic_1

  # Create instance: util_vector_logic_2, and set properties
  set util_vector_logic_2 [ create_bd_cell -type ip -vlnv xilinx.com:ip:util_vector_logic:2.0 util_vector_logic_2 ]
  set_property -dict [ list \
CONFIG.C_OPERATION {or} \
CONFIG.C_SIZE {1} \
CONFIG.LOGO_FILE {data/sym_orgate.png} \
 ] $util_vector_logic_2

  # Create instance: util_vector_logic_3, and set properties
  set util_vector_logic_3 [ create_bd_cell -type ip -vlnv xilinx.com:ip:util_vector_logic:2.0 util_vector_logic_3 ]
  set_property -dict [ list \
CONFIG.C_SIZE {1} \
 ] $util_vector_logic_3

  # Create port connections
  connect_bd_net -net STARTUP_0_user_clk [get_bd_pins A] [get_bd_pins util_vector_logic_0/Op1]
  connect_bd_net -net util_ds_buf_0_BUFG_O [get_bd_pins B] [get_bd_pins util_vector_logic_3/Op1]
  connect_bd_net -net util_vector_logic_0_Res [get_bd_pins util_vector_logic_0/Res] [get_bd_pins util_vector_logic_2/Op1]
  connect_bd_net -net util_vector_logic_1_Res [get_bd_pins util_vector_logic_0/Op2] [get_bd_pins util_vector_logic_1/Res]
  connect_bd_net -net util_vector_logic_2_Res [get_bd_pins C] [get_bd_pins util_vector_logic_2/Res]
  connect_bd_net -net util_vector_logic_3_Res [get_bd_pins util_vector_logic_2/Op2] [get_bd_pins util_vector_logic_3/Res]
  connect_bd_net -net vio_0_probe_out0 [get_bd_pins SEL] [get_bd_pins util_vector_logic_1/Op1] [get_bd_pins util_vector_logic_3/Op2]

  # Restore current instance
  current_bd_instance $oldCurInst
}

# Hierarchical cell: mux_4to1
proc create_hier_cell_mux_4to1 { parentCell nameHier } {

  variable script_folder

  if { $parentCell eq "" || $nameHier eq "" } {
     catch {common::send_msg_id "BD_TCL-102" "ERROR" create_hier_cell_mux_4to1() - Empty argument(s)!"}
     return
  }

  # Get object for parentCell
  set parentObj [get_bd_cells $parentCell]
  if { $parentObj == "" } {
     catch {common::send_msg_id "BD_TCL-100" "ERROR" "Unable to find parent cell <$parentCell>!"}
     return
  }

  # Make sure parentObj is hier blk
  set parentType [get_property TYPE $parentObj]
  if { $parentType ne "hier" } {
     catch {common::send_msg_id "BD_TCL-101" "ERROR" "Parent <$parentObj> has TYPE = <$parentType>. Expected to be <hier>."}
     return
  }

  # Save current instance; Restore later
  set oldCurInst [current_bd_instance .]

  # Set parent object as current
  current_bd_instance $parentObj

  # Create cell and set as current instance
  set hier_obj [create_bd_cell -type hier $nameHier]
  current_bd_instance $hier_obj

  # Create interface pins

  # Create pins
  create_bd_pin -dir I -from 0 -to 0 A
  create_bd_pin -dir I -from 0 -to 0 B
  create_bd_pin -dir I -from 0 -to 0 C
  create_bd_pin -dir I -from 0 -to 0 D
  create_bd_pin -dir I -from 1 -to 0 SEL
  create_bd_pin -dir O -from 0 -to 0 Z

  # Create instance: mux_2to1_1
  create_hier_cell_mux_2to1_1 $hier_obj mux_2to1_1

  # Create instance: mux_2to1_2
  create_hier_cell_mux_2to1_2 $hier_obj mux_2to1_2

  # Create instance: mux_2to1_3
  create_hier_cell_mux_2to1_3 $hier_obj mux_2to1_3

  # Create instance: xlslice_0, and set properties
  set xlslice_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:xlslice:1.0 xlslice_0 ]
  set_property -dict [ list \
CONFIG.DIN_FROM {1} \
CONFIG.DIN_TO {0} \
CONFIG.DIN_WIDTH {2} \
CONFIG.DOUT_WIDTH {2} \
 ] $xlslice_0

  # Create instance: xlslice_mux0, and set properties
  set xlslice_mux0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:xlslice:1.0 xlslice_mux0 ]
  set_property -dict [ list \
CONFIG.DIN_FROM {0} \
CONFIG.DIN_TO {0} \
CONFIG.DIN_WIDTH {2} \
CONFIG.DOUT_WIDTH {1} \
 ] $xlslice_mux0

  # Create instance: xlslice_mux1, and set properties
  set xlslice_mux1 [ create_bd_cell -type ip -vlnv xilinx.com:ip:xlslice:1.0 xlslice_mux1 ]
  set_property -dict [ list \
CONFIG.DIN_FROM {1} \
CONFIG.DIN_TO {1} \
CONFIG.DIN_WIDTH {2} \
CONFIG.DOUT_WIDTH {1} \
 ] $xlslice_mux1

  # Create port connections
  connect_bd_net -net LED_D4_1 [get_bd_pins Z] [get_bd_pins mux_2to1_3/C]
  connect_bd_net -net d4_mux_i [get_bd_pins SEL] [get_bd_pins xlslice_0/Din]
  connect_bd_net -net d4_user_i [get_bd_pins A] [get_bd_pins mux_2to1_1/A]
  connect_bd_net -net mux_1b1_C [get_bd_pins mux_2to1_1/C] [get_bd_pins mux_2to1_3/A]
  connect_bd_net -net mux_1b2_C [get_bd_pins mux_2to1_2/C] [get_bd_pins mux_2to1_3/B]
  connect_bd_net -net xlslice_0_Dout [get_bd_pins xlslice_0/Dout] [get_bd_pins xlslice_mux0/Din] [get_bd_pins xlslice_mux1/Din]
  connect_bd_net -net xlslice_mux0_Dout [get_bd_pins mux_2to1_1/SEL] [get_bd_pins mux_2to1_2/SEL] [get_bd_pins xlslice_mux0/Dout]
  connect_bd_net -net xlslice_mux1_Dout [get_bd_pins mux_2to1_3/SEL] [get_bd_pins xlslice_mux1/Dout]
  connect_bd_net -net xlslice_v0_Dout [get_bd_pins B] [get_bd_pins mux_2to1_1/B]
  connect_bd_net -net xlslice_v16_Dout [get_bd_pins C] [get_bd_pins mux_2to1_2/A]
  connect_bd_net -net xlslice_v32_Dout [get_bd_pins D] [get_bd_pins mux_2to1_2/B]

  # Restore current instance
  current_bd_instance $oldCurInst
}

# Hierarchical cell: mux_2to1
proc create_hier_cell_mux_2to1 { parentCell nameHier } {

  variable script_folder

  if { $parentCell eq "" || $nameHier eq "" } {
     catch {common::send_msg_id "BD_TCL-102" "ERROR" create_hier_cell_mux_2to1() - Empty argument(s)!"}
     return
  }

  # Get object for parentCell
  set parentObj [get_bd_cells $parentCell]
  if { $parentObj == "" } {
     catch {common::send_msg_id "BD_TCL-100" "ERROR" "Unable to find parent cell <$parentCell>!"}
     return
  }

  # Make sure parentObj is hier blk
  set parentType [get_property TYPE $parentObj]
  if { $parentType ne "hier" } {
     catch {common::send_msg_id "BD_TCL-101" "ERROR" "Parent <$parentObj> has TYPE = <$parentType>. Expected to be <hier>."}
     return
  }

  # Save current instance; Restore later
  set oldCurInst [current_bd_instance .]

  # Set parent object as current
  current_bd_instance $parentObj

  # Create cell and set as current instance
  set hier_obj [create_bd_cell -type hier $nameHier]
  current_bd_instance $hier_obj

  # Create interface pins

  # Create pins
  create_bd_pin -dir I -from 0 -to 0 A
  create_bd_pin -dir I -from 0 -to 0 B
  create_bd_pin -dir O -from 0 -to 0 C
  create_bd_pin -dir I -from 0 -to 0 SEL

  # Create instance: util_vector_logic_0, and set properties
  set util_vector_logic_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:util_vector_logic:2.0 util_vector_logic_0 ]
  set_property -dict [ list \
CONFIG.C_SIZE {1} \
 ] $util_vector_logic_0

  # Create instance: util_vector_logic_1, and set properties
  set util_vector_logic_1 [ create_bd_cell -type ip -vlnv xilinx.com:ip:util_vector_logic:2.0 util_vector_logic_1 ]
  set_property -dict [ list \
CONFIG.C_OPERATION {not} \
CONFIG.C_SIZE {1} \
CONFIG.LOGO_FILE {data/sym_notgate.png} \
 ] $util_vector_logic_1

  # Create instance: util_vector_logic_2, and set properties
  set util_vector_logic_2 [ create_bd_cell -type ip -vlnv xilinx.com:ip:util_vector_logic:2.0 util_vector_logic_2 ]
  set_property -dict [ list \
CONFIG.C_OPERATION {or} \
CONFIG.C_SIZE {1} \
CONFIG.LOGO_FILE {data/sym_orgate.png} \
 ] $util_vector_logic_2

  # Create instance: util_vector_logic_3, and set properties
  set util_vector_logic_3 [ create_bd_cell -type ip -vlnv xilinx.com:ip:util_vector_logic:2.0 util_vector_logic_3 ]
  set_property -dict [ list \
CONFIG.C_SIZE {1} \
 ] $util_vector_logic_3

  # Create port connections
  connect_bd_net -net STARTUP_0_user_clk [get_bd_pins A] [get_bd_pins util_vector_logic_0/Op1]
  connect_bd_net -net util_ds_buf_0_BUFG_O [get_bd_pins B] [get_bd_pins util_vector_logic_3/Op1]
  connect_bd_net -net util_vector_logic_0_Res [get_bd_pins util_vector_logic_0/Res] [get_bd_pins util_vector_logic_2/Op1]
  connect_bd_net -net util_vector_logic_1_Res [get_bd_pins util_vector_logic_0/Op2] [get_bd_pins util_vector_logic_1/Res]
  connect_bd_net -net util_vector_logic_2_Res [get_bd_pins C] [get_bd_pins util_vector_logic_2/Res]
  connect_bd_net -net util_vector_logic_3_Res [get_bd_pins util_vector_logic_2/Op2] [get_bd_pins util_vector_logic_3/Res]
  connect_bd_net -net vio_0_probe_out0 [get_bd_pins SEL] [get_bd_pins util_vector_logic_1/Op1] [get_bd_pins util_vector_logic_3/Op2]

  # Restore current instance
  current_bd_instance $oldCurInst
}


# Procedure to create entire design; Provide argument to make
# procedure reusable. If parentCell is "", will use root.
proc create_root_design { parentCell } {

  variable script_folder

  if { $parentCell eq "" } {
     set parentCell [get_bd_cells /]
  }

  # Get object for parentCell
  set parentObj [get_bd_cells $parentCell]
  if { $parentObj == "" } {
     catch {common::send_msg_id "BD_TCL-100" "ERROR" "Unable to find parent cell <$parentCell>!"}
     return
  }

  # Make sure parentObj is hier blk
  set parentType [get_property TYPE $parentObj]
  if { $parentType ne "hier" } {
     catch {common::send_msg_id "BD_TCL-101" "ERROR" "Parent <$parentObj> has TYPE = <$parentType>. Expected to be <hier>."}
     return
  }

  # Save current instance; Restore later
  set oldCurInst [current_bd_instance .]

  # Set parent object as current
  current_bd_instance $parentObj


  # Create interface ports

  # Create ports
  set LED_D4 [ create_bd_port -dir O -from 0 -to 0 LED_D4 ]
  set SYS_CLK [ create_bd_port -dir I -from 0 -to 0 SYS_CLK ]

  # Create instance: STARTUP_0, and set properties
  set STARTUP_0 [ create_bd_cell -type ip -vlnv trenz.biz:user:STARTUP:1.0 STARTUP_0 ]

  # Create instance: c_counter_binary_0, and set properties
  set c_counter_binary_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:c_counter_binary:12.0 c_counter_binary_0 ]
  set_property -dict [ list \
CONFIG.Output_Width {32} \
 ] $c_counter_binary_0

  # Create instance: labtools_fmeter_0, and set properties
  set labtools_fmeter_0 [ create_bd_cell -type ip -vlnv trenz.biz:user:labtools_fmeter:1.0 labtools_fmeter_0 ]
  set_property -dict [ list \
CONFIG.C_CHANNELS {3} \
CONFIG.C_REFCLK_HZ {65000000} \
 ] $labtools_fmeter_0

  # Create instance: mux_2to1
  create_hier_cell_mux_2to1 [current_bd_instance .] mux_2to1

  # Create instance: mux_4to1
  create_hier_cell_mux_4to1 [current_bd_instance .] mux_4to1

  # Create instance: util_ds_buf_0, and set properties
  set util_ds_buf_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:util_ds_buf:2.1 util_ds_buf_0 ]
  set_property -dict [ list \
CONFIG.C_BUF_TYPE {BUFG} \
 ] $util_ds_buf_0

  # Create instance: vio_0, and set properties
  set vio_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:vio:3.0 vio_0 ]
  set_property -dict [ list \
CONFIG.C_NUM_PROBE_IN {3} \
CONFIG.C_NUM_PROBE_OUT {3} \
CONFIG.C_PROBE_OUT1_WIDTH {2} \
 ] $vio_0

  # Create instance: xlconcat_0, and set properties
  set xlconcat_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:xlconcat:2.1 xlconcat_0 ]
  set_property -dict [ list \
CONFIG.NUM_PORTS {3} \
 ] $xlconcat_0

  # Create instance: xlslice_v0, and set properties
  set xlslice_v0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:xlslice:1.0 xlslice_v0 ]
  set_property -dict [ list \
CONFIG.DIN_FROM {0} \
CONFIG.DIN_TO {0} \
CONFIG.DOUT_WIDTH {1} \
 ] $xlslice_v0

  # Create instance: xlslice_v23, and set properties
  set xlslice_v23 [ create_bd_cell -type ip -vlnv xilinx.com:ip:xlslice:1.0 xlslice_v23 ]
  set_property -dict [ list \
CONFIG.DIN_FROM {23} \
CONFIG.DIN_TO {23} \
CONFIG.DOUT_WIDTH {1} \
 ] $xlslice_v23

  # Create instance: xlslice_v32, and set properties
  set xlslice_v32 [ create_bd_cell -type ip -vlnv xilinx.com:ip:xlslice:1.0 xlslice_v32 ]
  set_property -dict [ list \
CONFIG.DIN_FROM {31} \
CONFIG.DIN_TO {31} \
CONFIG.DOUT_WIDTH {1} \
 ] $xlslice_v32

  # Create port connections
  connect_bd_net -net BUFG_I_1 [get_bd_ports SYS_CLK] [get_bd_pins util_ds_buf_0/BUFG_I]
  connect_bd_net -net LED_D4_1 [get_bd_ports LED_D4] [get_bd_pins mux_4to1/Z] [get_bd_pins xlconcat_0/In2]
  connect_bd_net -net STARTUP_0_user_clk [get_bd_pins STARTUP_0/user_clk] [get_bd_pins labtools_fmeter_0/refclk] [get_bd_pins mux_2to1/A] [get_bd_pins vio_0/clk] [get_bd_pins xlconcat_0/In0]
  connect_bd_net -net c_counter_binary_0_Q [get_bd_pins c_counter_binary_0/Q] [get_bd_pins xlslice_v0/Din] [get_bd_pins xlslice_v23/Din] [get_bd_pins xlslice_v32/Din]
  connect_bd_net -net d4_mux_i [get_bd_pins mux_4to1/SEL] [get_bd_pins vio_0/probe_out1]
  connect_bd_net -net d4_user_i [get_bd_pins mux_4to1/A] [get_bd_pins vio_0/probe_out2]
  connect_bd_net -net led_freq [get_bd_pins labtools_fmeter_0/F2] [get_bd_pins vio_0/probe_in2]
  connect_bd_net -net sel_clk_i [get_bd_pins mux_2to1/SEL] [get_bd_pins vio_0/probe_out0]
  connect_bd_net -net startup_clk_freq [get_bd_pins labtools_fmeter_0/F0] [get_bd_pins vio_0/probe_in0]
  connect_bd_net -net sys_clk_freq [get_bd_pins labtools_fmeter_0/F1] [get_bd_pins vio_0/probe_in1]
  connect_bd_net -net util_ds_buf_0_BUFG_O [get_bd_pins mux_2to1/B] [get_bd_pins util_ds_buf_0/BUFG_O] [get_bd_pins xlconcat_0/In1]
  connect_bd_net -net util_vector_logic_2_Res [get_bd_pins c_counter_binary_0/CLK] [get_bd_pins mux_2to1/C]
  connect_bd_net -net xlconcat_0_dout [get_bd_pins labtools_fmeter_0/fin] [get_bd_pins xlconcat_0/dout]
  connect_bd_net -net xlslice_v0_Dout [get_bd_pins mux_4to1/B] [get_bd_pins xlslice_v0/Dout]
  connect_bd_net -net xlslice_v16_Dout [get_bd_pins mux_4to1/C] [get_bd_pins xlslice_v23/Dout]
  connect_bd_net -net xlslice_v32_Dout [get_bd_pins mux_4to1/D] [get_bd_pins xlslice_v32/Dout]

  # Create address segments

  # Perform GUI Layout
  regenerate_bd_layout -layout_string {
   guistr: "# # String gsaved with Nlview 6.5.12  2016-01-29 bk=1.3547 VDI=39 GEI=35 GUI=JA:1.6
#  -string -flagsOSRD
preplace portBus SYS_CLK -pg 1 -y 160 -defaultsOSRD
preplace portBus LED_D4 -pg 1 -y 90 -defaultsOSRD
preplace inst vio_0 -pg 1 -lvl 3 -y 140 -defaultsOSRD
preplace inst xlslice_v32 -pg 1 -lvl 9 -y 250 -defaultsOSRD
preplace inst mux_2to1 -pg 1 -lvl 4 -y 130 -defaultsOSRD
preplace inst xlconcat_0 -pg 1 -lvl 3 -y 330 -defaultsOSRD
preplace inst xlslice_v0 -pg 1 -lvl 9 -y 90 -defaultsOSRD
preplace inst mux_4to1 -pg 1 -lvl 10 -y 90 -defaultsOSRD
preplace inst c_counter_binary_0 -pg 1 -lvl 6 -y 130 -defaultsOSRD
preplace inst STARTUP_0 -pg 1 -lvl 2 -y 80 -defaultsOSRD
preplace inst xlslice_v23 -pg 1 -lvl 9 -y 170 -defaultsOSRD
preplace inst labtools_fmeter_0 -pg 1 -lvl 5 -y 320 -defaultsOSRD
preplace inst util_ds_buf_0 -pg 1 -lvl 1 -y 160 -defaultsOSRD
preplace netloc xlslice_v32_Dout 1 9 1 NJ
preplace netloc xlslice_v0_Dout 1 9 1 NJ
preplace netloc xlslice_v16_Dout 1 9 1 NJ
preplace netloc xlconcat_0_dout 1 3 2 NJ 330 N
preplace netloc sel_clk_i 1 3 1 740
preplace netloc c_counter_binary_0_Q 1 6 3 NJ 130 NJ 130 1430
preplace netloc BUFG_I_1 1 0 1 NJ
preplace netloc led_freq 1 2 4 470 220 NJ 220 NJ 220 1150
preplace netloc d4_user_i 1 3 7 770 40 NJ 40 NJ 40 NJ 40 NJ 40 NJ 40 NJ
preplace netloc util_vector_logic_2_Res 1 4 2 NJ 130 NJ
preplace netloc startup_clk_freq 1 2 4 450 230 NJ 230 NJ 230 1140
preplace netloc d4_mux_i 1 3 7 750 30 NJ 30 NJ 30 NJ 30 NJ 30 NJ 30 NJ
preplace netloc STARTUP_0_user_clk 1 2 3 430 50 780 50 940
preplace netloc LED_D4_1 1 2 16 470 400 NJ 400 NJ 400 NJ 400 NJ 400 NJ 400 NJ 400 NJ 400 1800 90 NJ 90 NJ 90 NJ 90 NJ 90 NJ 90 NJ 90 NJ
preplace netloc util_ds_buf_0_BUFG_O 1 1 3 NJ 160 440 60 NJ
preplace netloc sys_clk_freq 1 2 4 460 240 NJ 240 NJ 240 1130
levelinfo -pg 1 0 130 340 610 860 1040 1250 1360 1410 1520 1720 1820 1870 1920 1970 2020 2070 2120 2160 -top 0 -bot 410
",
}

  # Restore current instance
  current_bd_instance $oldCurInst

  save_bd_design
}
# End of create_root_design()


##################################################################
# MAIN FLOW
##################################################################

create_root_design ""



